﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.GridHelperClasses;


//using System.Linq;
using System.Collections.Specialized;
using Syncfusion.Windows.Forms.Grid;
//using Syncfusion.GridHelperClasses;



namespace s_test2f
{
    public partial class Form1 : Form
    {
        int nField0value = 0;
   
        public Form1()
        {
            InitializeComponent();

    

            // Add expression field descriptor values at the end of the Expression Fields
            this.gridGroupingControl1.TableDescriptor.ExpressionFields.AddRange(new Syncfusion.Grouping.ExpressionFieldDescriptor[] {
            new Syncfusion.Grouping.ExpressionFieldDescriptor("Result", "([Quantity] *[UnitPrice])", "System.Double")});
            //g1    this.gridGroupingControl1.TableDescriptor.VisibleColumns.Remove("value");

            this.gridGroupingControl1.TableControlCurrentCellAcceptedChanges += gridGroupingControl1_TableControlCurrentCellAcceptedChanges;
             this.gridGroupingControl1.TableControlCurrentCellStartEditing+=gridGroupingControl1_TableControlCurrentCellStartEditing;

            this.gridGroupingControl1.TableDescriptor.Columns["Quantity"].Appearance.AnyRecordFieldCell.Format = "N2";
            this.gridGroupingControl1.TableDescriptor.Columns["UnitPrice"].Appearance.AnyRecordFieldCell.Format = "C";
            this.gridGroupingControl1.TableDescriptor.Columns["Result"].Appearance.AnyRecordFieldCell.Format = "C";
            this.gridGroupingControl1.TableDescriptor.Columns["value"].Appearance.AnyRecordFieldCell.Format = "C";
            nField0value = this.gridGroupingControl1.TableModel.NameToField("value") + 1;

            //adding a new (*) line at the end of the table,
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordBeforeDetails = false;
            this.gridGroupingControl1.TopLevelGroupOptions.ShowAddNewRecordAfterDetails = true;



            // Copy and Paste    Please include the below code for copy paste functionality
            //this.gridGroupingControl1.TableModel.ClipboardCopy += new GridCutPasteEventHandler(TableModel_ClipboardCopy);
            //this.gridGroupingControl1.TableModel.ClipboardCut  += new GridCutPasteEventHandler(TableModel_ClipboardCut);

            

           
        }



       
        void TableModel_ClipboardCut(object sender, GridCutPasteEventArgs e)
        {
           // this.gridGroupingControl1.TableControl.Model.CutPaste.Paste();
        }



        void TableModel_ClipboardCopy(object sender, GridCutPasteEventArgs e)
        {
            try
            {
             //   this.gridGroupingControl1.TableControl.Model.CutPaste.Copy();
            }
            catch (Exception)
            {

                ;/// throw;
            }

          
        }



        void gridGroupingControl1_TableControlCurrentCellStartEditing(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
        {
          if (e.TableControl.CurrentCell.ColIndex == nField0value)
            {
                e.Inner.Cancel = true;
            }
        }


        void gridGroupingControl1_TableControlCurrentCellAcceptedChanges(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCancelEventArgs e)
        {
            //  2.     Using Style(this can be obtained using any events like current cell edit ,etc..)
            // Code :

            GridTableCellStyleInfo style = e.TableControl.GetTableViewStyleInfo(e.TableControl.CurrentCell.RowIndex, e.TableControl.CurrentCell.ColIndex);
            GridTableCellStyleInfoIdentity id = style.TableCellIdentity;
            Record rec = id.DisplayElement.GetRecord();
            //modified value of value column
            string modifiedvalue = rec.GetValue("Result").ToString();

            //2.
            GridCurrentCell cc = this.gridGroupingControl1.TableControl.CurrentCell;
            this.gridGroupingControl1.TableModel[cc.RowIndex - 0, nField0value].CellValue = modifiedvalue;
        }

        ////1.    Using DrawCellDisplayText
        //void gridGroupingControl1_TableControlDrawCellDisplayText(object sender, GridTableControlDrawCellDisplayTextEventArgs e)
        //{
        //    e.Inner.DisplayText; //  MessageBox.Show(""+e.Inner.DisplayText);
        //}

       



        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'test009DataSet.Order_Details' table. You can move, or remove it, as needed.
            this.order_DetailsTableAdapter.Fill(this.test009DataSet.Order_Details);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Form2 settingsForm = new Form2();
            settingsForm.Show();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Validate();
            //   this.order_DetailsBindingSource.EndEdit();
            this.order_DetailsTableAdapter.Update(this.test009DataSet);
        }


        private void insertToolStripMenuItem_Click(object sender, EventArgs e)//insert empty
        {
            //  gridGroupingControl1.TableModel.CutPaste.Paste();

            GridCurrentCell cc = this.gridGroupingControl1.TableControl.CurrentCell;
            DataRow tableRow1 = this.test009DataSet.Order_Details.NewRow();       
            this.test009DataSet.Order_Details.Rows.InsertAt(tableRow1, cc.RowIndex-2);
           
            this.test009DataSet.Order_Details.AcceptChanges();
            this.gridGroupingControl1.Refresh();
            this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(cc.RowIndex+1, 0);


        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
           
         //   gridGroupingControl1.TableModel.CutPaste.Copy();

           //// For insert you should use ForceImmediateSaveCellInfo in GGC similar to DirectSaveCellInfo
           // //Forces the GridGroupingControl to save the edited values while leaving the CurrentCell.

           // foreach (FieldDescriptor col in this.gridGroupingControl1.TableDescriptor.Fields)
           //     this.gridGroupingControl1.TableDescriptor.Fields[col.Name].ForceImmediateSaveValue = true;



            GridCurrentCell cc = this.gridGroupingControl1.TableControl.CurrentCell;
            this.gridGroupingControl1.TableControl.Selections.Add(GridRangeInfo.Row(cc.RowIndex)); //add selection to the full row.
            this.gridGroupingControl1.TableControl.Model.CutPaste.Copy();

            insertToolStripMenuItem_Click(sender, e);
            this.gridGroupingControl1.TableControl.Selections.Clear();
            this.gridGroupingControl1.TableControl.CurrentCell.MoveTo(cc.RowIndex + 0, cc.ColIndex);
            this.gridGroupingControl1.TableControl.Selections.Add(GridRangeInfo.Row(cc.RowIndex));
            this.gridGroupingControl1.TableControl.Model.CutPaste.Paste();
        }

        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.gridGroupingControl1.Table.SelectedRecords.DeleteAll();
         }


    }
}
